/// <reference types="react" />
import "pdfjs-dist/web/pdf_viewer.css";
import "../style/pdf_viewer.css";
import "../style/PdfHighlighter.css";
import type { PDFDocumentProxy } from "pdfjs-dist";
import type { IHighlight, LTWH, LTWHP, Position, Scaled } from "../types";
type T_ViewportHighlight<T_HT> = {
    position: Position;
} & T_HT;
type PdfHighlighterProps<T_HT> = {
    highlightTransform: (highlight: T_ViewportHighlight<T_HT>, index: number, setTip: (highlight: T_ViewportHighlight<T_HT>, callback: (highlight: T_ViewportHighlight<T_HT>) => JSX.Element) => void, hideTip: () => void, viewportToScaled: (rect: LTWHP) => Scaled, screenshot: (position: LTWH) => string, isScrolledTo: boolean) => JSX.Element;
    highlights: Array<T_HT>;
    onScrollChange: () => void;
    scrollRef: (scrollTo: (highlight: T_HT) => void) => void;
    pdfDocument: PDFDocumentProxy;
    pdfScaleValue?: string;
};
export declare const PdfHighlighter: <T_HT extends IHighlight>({ highlightTransform, highlights, onScrollChange, scrollRef, pdfDocument, pdfScaleValue, }: PdfHighlighterProps<T_HT>) => JSX.Element;
export {};
