var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useRef } from "react";
export const MouseMonitor = (props) => {
    const container = useRef(null);
    let unsubscribe = () => { };
    const { onMoveAway, paddingX, paddingY, children } = props, restProps = __rest(props, ["onMoveAway", "paddingX", "paddingY", "children"]);
    const onMouseMove = (event) => {
        if (!container)
            return;
        let current = container.current;
        if (!current)
            return;
        const { clientX, clientY } = event;
        const { left, top, width, height } = current.getBoundingClientRect();
        const inBoundsX = clientX > left - paddingX && clientX < left + width + paddingX;
        const inBoundsY = clientY > top - paddingY && clientY < top + height + paddingY;
        const isNear = inBoundsX && inBoundsY;
        if (!isNear) {
            onMoveAway();
        }
    };
    const attachRef = (ref) => {
        container.current = ref;
        unsubscribe();
        if (ref) {
            const { ownerDocument: doc } = ref;
            doc.addEventListener("mousemove", onMouseMove);
            unsubscribe = () => {
                doc.removeEventListener("mousemove", onMouseMove);
            };
        }
    };
    return (React.createElement("div", { ref: (ref) => attachRef(ref) }, React.cloneElement(children, restProps)));
};
//# sourceMappingURL=MouseMonitor.js.map